
	list	p=16F84A
	#include <p16F84A.inc>       ; processor specific variable definitions
	radix	hex

	__CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC

	udata

Delay1 		res 1	; reserve a byte for a delay counter
Delay2 		res 1	; reserve another byte for a delay counter
led_counter	res 1	; reserve one byte for our led counter


	org	0x005

start	
	movlw	b'00001111'	; load W with b'00001111'
						; we will reserve RB7,RB6,RB5,RB4 for output
	tris	PORTB		; enable the selected pins for output
	clrf	PORTB		; clear PORT B
    
	movlw	b'00010000'	; move b'00001111' to register w
	movwf	led_counter	; move register w to led_counter


my_loop	
   	call	change_leds	; changed the leds
   	call	pause		; wait a few cycles
	goto	my_loop		; repeat

; ------------------------------------
; pause
; ------------------------------------

pause

my_delay:
	DECFSZ Delay1,1		;Decrement Delay1 by 1, skip next instruction if Delay1 is 0
	GOTO my_delay  
	DECFSZ Delay2,1
	GOTO my_delay
	return			

; ------------------------------------
; change_lights
; ------------------------------------

change_leds

	decf   led_counter,1	; led_counter = led_counter - 1

	swapf	led_counter,0	; we need to shift the value of led_counter
							; so that the lower half of the byte
							; displays on pins 4-7
							; This new value will be in register w
	movwf	PORTB			; move w to PORTB

	movfw	led_counter
	bz	reset_counter		; if led_counter == 0, then jump to 'reset_counter'
	return

reset_counter				; reset led_counter to b'00010000'
	movlw	b'00010000'		; move b'00001111' to register w
	movwf	led_counter		; move register w to led_counter
	return

	end
